.nolist
include \masm32\include\masm32rt.inc
include CpuId.inc
include \masm32\macros\timers.asm

.686
.xmm

markl_CountFileLines	PROTO: DWORD
CompteurLignes		PROTO: DWORD, :DWORD
getlines		PROTO: DWORD, :DWORD
getlines2		PROTO: DWORD, :DWORD 
getlinesJJ		PROTO: DWORD, :DWORD

	LOOP_COUNT	= 2000
	CheckBadLines	= 0	; 15 bytes more: report string, LF, string

.data?
cbFile	dd ?
hFile	dd ?
Win$	dd ?
bytesread	dd ?
BadLines	dd ?

.data
;wininc	db "\masm32\include\winextra.inc", 0
wininc	db "\masm32\include\windows.inc", 0
crlf	equ 13, 10

align 16
	db 0, 0, 0, 0, 0
gltestA	db "A test", 10, "string", 10, crlf, 10, 10
	db "This is STRING A", crlf	; 33
	db "This is a very very BAD STRING B", 10
	REPEAT 100-3
	  db "This is a test string", crlf
	  ENDM
	db "This is a very BAD test string", 10
	db "This is a really, really good test string", 10, crlf, 0	; end of string - 100 valid lines, 7 bad lines
	; v v v nasty remainders from previous file reads
	db crlf, crlf, crlf, crlf, crlf, crlf
	
align 16

gltestB	db "B test string", crlf
	db "This is string A", crlf
	db "This is a BAD string B", 10
	db "This is BAD string C", 10
	db "And BAD string D", 10
	db "This is string B", crlf
	db "And BAD E", 10
	REPEAT 100-5
	db "This is a test string", crlf
	ENDM
	db "This is a BAD test string", 10
	db "This is a good test string", crlf
	db "This is a BAD test string", 10
	db "This is a test string", 10, crlf, 0	; end of string - 100 valid lines, 7 bad lines
	; v v v nasty remainders from previous file reads
	db crlf, crlf, crlf, crlf, crlf, crlf

align 16
; db 1, 2, 3
Texte  db 13,10,13,10,13,10,13,10	; [url=http://www.masm32.com/board/index.php?topic=11061.msg81704#msg81704]ToutEnMasm[/url]
  db "   windowsinc   FichMem <>",13,10
  db "InfosFichiers WIN32_FIND_DATA <>",13,10
  db 13,10
  db "   ;procder  des essais sous surveillances",13,10
  db "   ;en cas d'exception,si la pile n'est pas dtruite",13,10
  db "      ;------- ajouter des feuilles SDI,utiliser menu CODE --> crer SDI",13,10
  db "               invoke ChargerFichierMem,SADR(\masm32\include\windows.inc),addr windowsinc",13,10
  db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.code

start:
	invoke ShowCPU, 1
	if CheckBadLines
		print chr$(13, 10, "Tests for correctness - 100+7 / 100+7 / 11+0 lines",13,10,"expected, first string 5-byte misaligned:", 13, 10, 10)
	else
		print chr$(13, 10, "Tests for correctness - 100 / 100 / 11 lines",13,10,"expected, first string 5-byte misaligned:", 13, 10, 10)
	endif
	if 0
	print "Mark Larson=",9
	; invoke markl_CountFileLines, offset gltestA ;, len(offset gltestA)
	print "--- / "
	; invoke markl_CountFileLines, offset gltestB ;, len(offset gltestB)
	print "--- (throws exception)", 13, 10
	endif
	print "jj2007=      ",9
	invoke getlinesJJ, offset gltestA, len(offset gltestA)
	if CheckBadLines
		print str$ (eax), "+"
		print str$ (BadLines), " / "
	else
		print str$ (eax), " / "
	endif
	invoke getlinesJJ, offset gltestB, len(offset gltestB)
	if CheckBadLines
		print str$ (eax), "+"
		print str$ (BadLines), " / "
	else
		print str$ (eax), " / "
	endif
	invoke getlinesJJ, offset Texte, len(offset Texte)
	if CheckBadLines
		print str$ (eax), "+"
		print str$ (BadLines), " lines", 13, 10
	else
		print str$ (eax), " lines", 13, 10
	endif

	print "Lingo=      ",9
	 invoke getlines, offset gltestA, len(offset gltestA)
	;print "--- / "
	print str$ (eax), " / "
	invoke getlines, offset gltestB, len(offset gltestB)
	print str$ (eax), " / "
	invoke getlines, offset Texte, len(offset Texte)
	print str$ (eax), " lines", 13, 10


	print "Lingo2=      ",9
	 invoke getlines2, offset gltestA, len(offset gltestA)
	;print "--- / "
	print str$ (eax), " / "
	invoke getlines2, offset gltestB, len(offset gltestB)
	print str$ (eax), " / "
	invoke getlines2, offset Texte, len(offset Texte)
	print str$ (eax), " lines", 13, 10


	print "ToutEnMasm=",9
	invoke CompteurLignes, offset gltestA, len(offset gltestA)
	print str$ (eax), " / "
	invoke CompteurLignes, offset gltestB, len(offset gltestB)
	print str$ (eax), " / "
	invoke CompteurLignes, offset Texte, len(offset Texte)
	print str$ (eax), " lines", 13, 10, 10	
	
	print "Codesizes: ", 13, 10

;	print "Mark Larson =       ", 9
;	mov eax, offset markl_CountFileLinesE-markl_CountFileLines
;	print str$(eax), 13, 10

	print "getlinesJJ =         ", 9
	mov eax, offset getlinesJJE-getlinesJJ
	print str$(eax), 13, 10

	print "getlines Lingo =", 9
	mov eax, offset getlinesE-getlines
	print str$(eax), 13, 10

	print "getlines2 Lingo2 =", 9
	mov eax, offset getlinesE2-getlines2
	print str$(eax), 13, 10


	print "CompteurLignes =", 9
	mov eax, offset CompteurLignesE-CompteurLignes
	print str$(eax), 13, 10, 10

	mov eax, alloc$(100000000)
	and eax, -16	; Lingo's code chokes for data not aligned to a 16 bytes boundary
	mov Win$, eax
	print "Counting lines of "
	print offset wininc, ":", 13, 10, 10
	mov hFile, fopen(offset wininc)
	mov cbFile, fsize(eax)
	invoke ReadFile, hFile, Win$, cbFile, offset bytesread, 0
	fclose hFile

	if 0
	print "markl_CountFileLines (Mark Larson):", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke markl_CountFileLines, Win$
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10
	endif
	print "getlinesJJ: (jj2007)", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke getlinesJJ, Win$, cbFile
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10

	if 1
	print "getlines (Lingo):", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke getlines, Win$, cbFile
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	;
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10

	print "getlines2 (Lingo2):", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke getlines2, Win$, cbFile
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	;
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10





	endif
	if 1
	print "CompteurLignes: (ToutEnMasm)", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke CompteurLignes, Win$, cbFile
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10
	endif

	inkey "Hit any key"
	exit

OPTION PROLOGUE:none
OPTION EPILOGUE:none
markl_CountFileLines proc src:DWORD	; [url=http://www.masm32.com/board/index.php?topic=5434.msg40666#msg40666]Mark Larson[/url]
  mov eax,0a0a0a0ah

  movd xmm7,eax
  mov edx, [esp+4]	; Win$	; offset [pFilebuffer]
  pshufd xmm7,xmm7,00000000b
  mov ecx, [cbFile]

  pxor xmm6, xmm6

  shr ecx,11 ;divide by 128*16
  jnc evenly_divisible
  inc ecx
evenly_divisible:

@@:
  pxor xmm5, xmm5
  ;i think it is the unrolling that is hosing things.
  i = 0
  WHILE i LT (16*128)
	movdqu xmm0, [edx + i +  0]
	movdqu xmm1, [edx + i + 16]
	movdqu xmm2, [edx + i + 32]
	movdqu xmm3, [edx + i + 48]

	pcmpeqb xmm0, xmm7
	pcmpeqb xmm1, xmm7
	pcmpeqb xmm2, xmm7
	pcmpeqb xmm3, xmm7

	paddb xmm0, xmm1
	paddb xmm2, xmm3

	paddb xmm0, xmm2

	; can't you do this step outside the loop?  I am pretty sure you can.
	psubb xmm5, xmm0 ; total 128*8 max = 1K
	i=i+16*4
  ENDM

; unpack MM5 to get sum in 1K block
pxor xmm0, xmm0
psadbw xmm5, xmm0
paddd xmm6, xmm5

dec ecx
lea edx, [edx + 128*16]
jne @B

movd eax, xmm6
psrldq xmm6,8 ;shift Right 8 bytes
movd ebx, xmm6
add eax, ebx
ret 4
markl_CountFileLines ENDP
markl_CountFileLinesE:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

CompteurLignes PROC uses ebx edi esi pmem:DWORD,taille:DWORD
			Local  Nblines:DWORD,count,reste
			local  theEnd:dword
	;init
	mov Nblines,0
	mov reste,0	
	mov edx,pmem
	add edx,taille
	mov theEnd,edx
	mov edx,pmem
	mov esi,edx	
	and edx,0Fh
	.if edx != 0
		;search lines in the non align memory
		mov ecx,16
		sub ecx,edx
		@@:
		.if byte ptr [esi] != 0
			.if word ptr [esi] == 0A0Dh
				inc Nblines			
			.endif
		.else
			mov eax,Nblines
			jmp FindeCompteurLignes
		.endif
		inc esi
		dec ecx
		jnz @B		
	.endif
	;esi point on a 16 aligned memory
	;count the number  of 32 bytes parts 
	mov edx, 0
	mov eax, theEnd
	sub eax, esi
	; .if eax == 0				; threw exception for negative byte count
	.if sdword ptr eax <= 0		; foolproof ;-)
		mov eax, Nblines
		jmp FindeCompteurLignes		
	.endif
	.if eax < 32
		mov reste,eax
		mov eax,Nblines		
		jmp EndNonaligned
	.endif
	mov edx,0
	mov ecx,32
	div ecx
	mov count,eax		
	mov reste,edx
	;--------------------------  search in aligned part -------------		
	;init of various register
	mov eax, 0d0d0d0dh	; Ascii 10, linefeed
	movd xmm6, eax
	pshufd xmm6, xmm6, 0	; linefeeds for comparison in xmm2	
	mov eax,Nblines	;line counter
	;ready
	NewBloc:
		;------ align 16 needed ----------
		;1731187 cycles for 22274 lines
		movdqa xmm1,xmm6			;charge 13
		movdqa xmm2,xmm6			;charge 13		
		pcmpeqb  xmm1,[esi]		;cmp with memory align 16		
		pcmpeqb  xmm2,[esi+16]		;cmp with memory ,align 16						
		pmovmskb ecx, xmm1 ; result in ecx 
		pmovmskb edx, xmm2 ; result +16 edx 
		shl edx,16
		add ecx,edx
		jz suite
		NbLineBreak:
		bsf	edx,	ecx
		jz suite
		.if 	word	ptr [edx+esi] == 0A0Dh
			inc	eax
		.endif
		btr	ecx,	edx
		jmp NbLineBreak
	suite:
	lea esi,[esi+32]
	dec count
	jnz NewBloc
	
EndNonaligned:	
	.if reste != 0
		mov ecx,reste
		@@:
		.if word ptr [esi] == 0A0Dh
			inc eax
		.endif	
		inc esi
		dec ecx
		jnz @B						
	.endif
	
 FindeCompteurLignes:
 ret
CompteurLignes endp
CompteurLignesE:
 
ALIGN16 equ
CompteurLignesO2 PROC uses ebx edi esi pmem:DWORD,taille:DWORD
			local  theEnd:dword
			Local  retour:DWORD
			
	;init of various register
	lea eax,sse2entree
	movups xmm6,[eax]
	mov eax,taille			;the size is a multiple of 16
	add eax,pmem			;
	mov theEnd,eax
	mov esi,pmem		
	mov eax,0	;line counter
	;ready
	NewBloc:
	IF 1	; DEF ALIGN16
		;------ align 16 needed ----------
		movdqa xmm1,xmm6			;charge 13
		movdqa xmm2,xmm6			;charge 13		
		pcmpeqb  xmm1,[esi]		;cmp with memory align 16		
		pcmpeqb  xmm2,[esi+16]		;cmp with memory ,align 16				
	ELSE
		movdqu xmm1,[esi]			;charge 13
		movdqu xmm2,[esi+16]			;charge 13		
		pcmpeqb  xmm1,xmm6		;13 ,xmm1 modified ,align 16	
		pcmpeqb  xmm2,xmm6		;13 ,xmm1 modified ,align 16				
	ENDIF
		
	pmovmskb ecx, xmm1 ; result in ecx 
	pmovmskb edx, xmm2 ; result +16 edx 
	shl edx,16
	add ecx,edx
		
	NbLineBreak:
	bsf	edx,	ecx
	jz suite
	.if 	word	ptr [edx+esi] == 0A0Dh
		inc	eax
	.endif
	btr	ecx,	edx
	jmp NbLineBreak

	suite:
	lea esi,[esi+32]
	.if esi < theEnd
		jmp NewBloc
	.endif

 FindeCompteurLignes:
         ret
CompteurLignesO2 endp

CompteurLignesOld PROC uses ebx edi esi pmem:DWORD,taille:DWORD
			local  theEnd:dword,retenue:DWORD
			Local  retour:DWORD
.data
	sse2entree 	db 13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,0 
	sse2line	db 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,0
.code
	;init of various register
	mov retenue,0
	lea eax,sse2entree
	movups xmm6,[eax]
	lea eax,sse2line
	movups xmm7,[eax]
	mov eax,pmem
	add eax,taille
	mov theEnd,eax
	mov edx,pmem
	mov eax,0	;line counter
	;ready
	NewBloc:
	if 0	; new version, to be completed
		movups xmm1,[edx]		;load 16 bytes
		movups xmm2,[edx+1]	;decale of 1
		pcmpeqb xmm1,xmm6	;13 ,xmm1 modified
		pcmpeqb xmm2,xmm7	;10 ,xmm2 modified
		pand xmm1,xmm2		;et logique FF et 00 = 0,result in xmm1
		pmovmskb ecx, xmm1	; result for 13,10 in ecx
		@@:
		mov edi,0			;take care with undeterminate state
		bsf edi,ecx		;search the 13,10
		.if edi == 0 && ecx != 0
			btr ecx,edi	;delet the bit find in edx,10
			inc eax		;inc the number of lines
		.elseif edi != 0
			btr ecx,edi	;delet the bit find in edx,10
			inc eax
		.endif
		.if ecx != 0
			jmp @B
		.endif
	else
	mov edx,pmem
	movups xmm1,[edx]			;load 16 bytes
	movups xmm2,[edx]			;charger les mmes 16 bytes
	pcmpeqb  xmm1,xmm6		;13 ,xmm1 modified
	;ff 00 ff 00 ff 00 ff 00-00 00 00 00 00 00 00 00  ;example of modified xmm1 in the dugger
	pcmpeqb  xmm2,xmm7		;10 ,xmm2 modified	
	;00 ff 00 ff 00 ff 00 ff-00 00 00 00 00 00 00 00  ;modified xmm2
	;--------- debug ---------
	;lea edx,TamponVisu1		;just here to view the result in the debugger
	;movups [edx],xmm1
	;lea edx,TamponVisu2	
	;movups [edx],xmm2		
	;-------- debug ------------------
	;the ;ff 00 ff .... must be read right to left
	;ecx and edx must be read left to right
	pmovmskb ecx, xmm1 ;1010101	;result for 13 in ecx  
	pmovmskb edx, xmm2 ;10101010	;result for 10 in edx
	;each 13 are now only  a  bit in ecx
	;each 10 are now only a bit in edx 
	;---------- search for bits and there positions -------
	;instructions are internal and very fast
	;ecx and edx have now her bits set to 1 as the same position 

	endif
	
	.if retenue == 1
		;the last 16 bytes loaded was ended by a 13,bit 15
		;Test if bit zero is one (there is a 10)
		bsf  edi,edx		;search the 10
		.if edi == 0 && edx != 0	
			btr edx,edi			;delet the bit find in edx,10
			inc eax			;inc the number of lines
		.endif				
	.endif
	NewEntree:
	bsf	ebx,ecx			;give the position of one bit at 1
	.if ebx == 0 && ecx != 0
		;le bit zero est a 1
		jmp bitzero13a1
	.endif
	.if ebx				;not zero ,on a un 13			
		bitzero13a1:
		btr ecx,ebx			;efface le bit trouv dans ecx
		.if ebx != 15
			inc ebx		      ;incrmente sa positon pour la comparer au 10
		.elseif
			mov retenue,1	;le 10 va se trouver dans le chargement suivant
			jmp NewSeriede16
			;suite a voir
		.endif
		
		traiteretenue:
		bsf  edi,edx		;cherche le 0A
		.if edi == 0 && edx != 0
			;le bit zero des 10 est a 1
			jmp bitzero10a1
		.endif
		.if  edi
			bitzero10a1:
			btr edx,edi			;efface le bit trouv dans edx,10			
			.if ebx == edi	;un 10 suit immdiatement le 13		
				inc eax	;////////// inc the number of lines /////////////////
			.elseif ebx >edi
				;this 10 is alone
				;c'est un 10 isol avant le 13 ,HTML
				mov edi,0
				jmp traiteretenue 
			.endif
		.endif
		;------ conditions de rebouclage ---------------
		.if ecx != 0
			mov ebx,0		;avoid an undeterminated state
			mov edi,0
			jmp NewEntree
		.endif
	.endif
	NewSeriede16:
	mov edx,pmem
	add edx,16	
	mov pmem,edx
	.if edx < theEnd
		jmp NewBloc
	.endif

 FindeCompteurLignes:
         ret
CompteurLignesOld endp

OPTION PROLOGUE:none
OPTION EPILOGUE:none
align 16
db 5 Dup(0) 
getlines proc pBuffer:dword, nSize:dword

;db 0cch
	pop 		ecx				; 
	pop 		eax				; eax->pBuffer
	mov 		[esp-4],	ebx		; preserve ebx register
	pop 		edx				; edx ->size of buffer
	xor 		ebx,		ebx		; ebx->counter=0
	add		edx,		eax		; edx->end of buffer
@@:							;		
	cmp 		eax,	edx			; is it end of buffer?
	jg		@ex3				; yes, exit
	test		eax, 	15			; is it 	32 bytes aligned?
	je		@f				; jmp if 32 bytes aligned
	cmp 		word 	ptr [eax], 0A0Dh	; lookin for 0a0d word in first non aligned area
	lea		eax, 	[eax+1]		;
	jne		@b				;
	inc 		eax				;
	inc		ebx				; inc counter->ebx
	jne		@b				;
db 15 Dup(0)
@@:							;		
	mov 		[esp-4], 	esi		; preserve esi register 
	mov		ecx, 	0a0a0a0ah		; 0Ah->second byte to looking for 
	mov		esi, 	edx			; esi->end of buffer 	
	movd 		xmm2,	ecx			; ecx = 0a0a0a0ah
	pshufd 	xmm2, xmm2, 0		; xmm2=0a0a0a0a0a0a0a.....
LoopM:
	movdqa	xmm1,	[eax+16]	
	movdqa	xmm0,	xmm2	
	pcmpeqb	xmm1,	xmm2
	pcmpeqb	xmm0,	[eax]
	pmovmskb 	ecx, 	xmm1
	pmovmskb 	edx, 	xmm0
	add		eax,	32
 	cmp 		eax,	esi
	jnc		@ex1
LM1:
	shl		ecx,	16
	db 		3Eh
	add		ecx,	edx
	jz		LoopM
LM2:	
	bsf 		edx, ecx
	cmp 		byte ptr [edx+eax-33], 0Dh
	jne 		@f
	inc 		ebx				; inc counter
@@:
	btr 		ecx, edx			; clear bit
	test 		ecx, ecx			; is there more bits?
	jne		LM2
	movdqa	xmm1,	[eax+16]	
	movdqa	xmm0,	xmm2	
	pcmpeqb	xmm1,	xmm2
	pcmpeqb	xmm0,	[eax]
	pmovmskb 	ecx, 	xmm1
	pmovmskb 	edx, 	xmm0
	add		eax,	32
 	cmp 		eax,	esi
	jc		LM1
@ex1:
	cmp 	word 	ptr [eax-32], 0A0Dh
	lea	eax, 	[eax-31]
	jne	@f
	db	3Eh
	inc	eax
	inc	ebx 					; inc counter->ebx
@@:				
	cmp 	eax,	esi				; is it end of buffer?
	jge	@ex2					; yes, exit
	cmp 	word 	ptr [eax], 0A0Dh
	lea	eax, 	[eax+1]		
	jne	@b				
	inc	eax
	add	ebx,	1				; inc counter->ebx
	jne	@b
align 16
@ex2:
	mov	esi, 	[esp-4]			; restore esi	
@ex3:
	mov 	eax,	ebx				; eax->counter	
	mov 	ebx,	[esp-8]			; restore ebx
	jmp 	dword	ptr [esp-12]		; jmp to return address
getlines endp
getlinesE:


align 16
db 5 Dup(0) 
getlines2 proc pBuffer:dword, nSize:dword
	pop 		ecx				; 
	pop 		eax				; eax->pBuffer
	mov 		[esp-4],	ebx		; preserve ebx register
	pop 		edx				; edx ->size of buffer
	xor 		ebx,		ebx		; ebx->counter=0
	add		edx,		eax		; edx->end of buffer
@@:							;		
	cmp 		eax,	edx			; is it end of buffer?
	jg		@ex3q				; yes, exit
	test		eax, 	15			; is it 	32 bytes aligned?
	je		@f				; jmp if 32 bytes aligned
	cmp 		word 	ptr [eax], 0A0Dh	; lookin for 0a0d word in first non aligned area
	lea		eax, 	[eax+1]		;
	jne		@b				;
	inc 		eax				;
	inc		ebx				; inc counter->ebx
	jne		@b				;
db 11 Dup(0)
@@:							;		
	mov 		[esp-4], 	esi		; preserve esi register 
	mov		ecx, 	0a0d0a0dh		; 0Ah->second byte to looking for 
	mov		esi, 	edx			; esi->end of buffer 	
	movd 		xmm7,	ecx			; ecx = 0a0a0a0ah
	pxor		xmm6,	xmm6			;xmm6->result = 0
	pshufd 	xmm7, xmm7, 0		; xmm7=0a0a0a0a0a0a0a.....
LoopMq:
	movdqa	xmm4,	[eax]
	movdqu	xmm5,	[eax+1]	
	pcmpeqw 	xmm4, xmm7
	movdqa	xmm1,	[eax+16]	
	pcmpeqw 	xmm5, xmm7
	movdqu	xmm2,	[eax+17]	
	paddsw 	xmm5, xmm4
	movdqa	xmm4,	[eax+32]	
	pcmpeqw 	xmm1, xmm7
	movdqu	xmm0,	[eax+33]	
	pcmpeqw 	xmm2, xmm7
	movdqa	xmm3,	[eax+48]	
	paddsw 	xmm5, xmm1
	movdqu	xmm1,	[eax+49]	
	pcmpeqw 	xmm4, xmm7
	pcmpeqw 	xmm0, xmm7
	paddsw 	xmm5, xmm4
	pcmpeqw 	xmm1, xmm7
	paddsw 	xmm5, xmm0
	pcmpeqw 	xmm3, xmm7
	paddsw 	xmm5, xmm1
	pxor		xmm0, xmm0
	paddsw 	xmm5, xmm3
	pxor		xmm4, xmm4
	paddsw 	xmm5, xmm2
	psubw 	xmm0, xmm5
	psadbw 	xmm0, xmm4
	paddd		xmm6, xmm0
	add		eax,	64
 	cmp 		eax,	esi
	jl 		LoopMq 
@ex1q:
	cmp 	word 	ptr [eax-64], 0A0Dh
	lea	eax, 	[eax-63]
	jne	@f
	db	3Eh
	inc	eax
	inc	ebx 					; inc counter->ebx
@@:				
	cmp 	eax,	esi				; is it end of buffer?
	jge	@ex2q					; yes, exit
	cmp 	word 	ptr [eax], 0A0Dh
	lea	eax, 	[eax+1]		
	jne	@b				
	inc	eax
	add	ebx,	1				; inc counter->ebx
	jne	@b
align 16
@ex2q:
	psubd	xmm6, xmm0
	movd 	eax, xmm6
	psrldq xmm6 , 8		 		;   shift right 8 
	movd 	ecx, xmm6
	mov	esi, 	[esp-4]			; restore esi	
	add 	eax, ebx
	mov 	ebx,	[esp-8]			; restore ebx
	add	eax, ecx
	jmp 	dword	ptr [esp-12]		; jmp to return addres
@ex3q:
	mov 	eax,	ebx				; eax->counter	
	mov 	ebx,	[esp-8]			; restore ebx
	jmp 	dword	ptr [esp-12]		; jmp to return address
getlines2 endp
getlinesE2:



getlinesJJ proc src:DWORD, ct:DWORD	; with some inspiration from Lingo, NightWare and Agner Fog
	mov eax, 0a0a0a0ah	; Ascii 10, linefeed
	movd xmm2, eax
	pshufd xmm2, xmm2, 0	; linefeeds for comparison in xmm2
	pushad
	mov esi, [esp+8+32]		; len(buffer)
	mov edi, [esp+4+32]		; edi = src
	add esi, edi					; esi = src + len(buffer)
	mov ecx, edi
	xor edx, edx				; pre-line counter
	if CheckBadLines
		xor ebx, ebx		; test for malformed lines, i.e. LF without preceding CR
	endif
	and ecx, 15				; test align 16
	je L0					; no alignment problem
	neg ecx
	add ecx, 16
	mov al, 10				; LF

rsb:
	repne scasb
	cmp byte ptr [edi-2], 13
	jne @F					; either we are done, or there was an error
	inc edx					; one correct line more
	test ecx, ecx
	je L0					; we are done
	jmp rsb					; one loop more
	
@@:	cmp byte ptr [edi-1], 10	; if not LF, it means we are done
	if CheckBadLines
		jne L0
		inc ebx				; if it was a LF, then we had a problem
		jmp rsb
	else
		je rsb
	endif

L0:	mov eax, edx					; line counter

L1:	movaps xmm0, xmm2			; linefeeds in xmm0 & xmm1
	pcmpeqb xmm0, [edi+16]	; compare packed bytes in [m128] and xmm0 for equality
	pmovmskb ecx, xmm0			; set byte mask in edx for second 16 byte chunk

	movaps xmm0, xmm2			; linefeeds in xmm0 (pcmpeqb resets xmm0 to zero - we must reload it!)
	pcmpeqb xmm0, [edi]			; compare packed bytes in [m128] and xmm0 for equality
	pmovmskb edx, xmm0		; set byte mask in edx for first 16 byte chunk

	lea edi, [edi+32]			; point to next chunk
	cmp edi, esi					; test boundary
	jae L2
	shl ecx, 16
	or edx, ecx
	jz L1						; z=no LF in here (removing this jump saves 2 bytes but costs 25 cycles...)

@@:	bsf ecx, edx					; bit scan forward
	je L1						; 0=no more 0A in first 16 bytes, we are done here
	inc eax
	btr edx, ecx					; clear that bit
	cmp byte ptr [edi+ecx-33], 13
	je @B						; OK, CrLf, one more bit scan
	dec eax						; that was an error!
	if CheckBadLines
		inc ebx
	endif
	jmp @B

L2:	sub edi, 32					; same: lea edi, [edi-32]
	mov ecx, esi				; esi = src + len(buffer)
	sub ecx, edi

@@:	movzx edx, word ptr [edi]
	.if dh==10
		if 0
			cmp dl, 13			; 5 bytes more, not faster 
			setz dh
			movzx edx, dh
			add eax, edx
		else
		.if dl==13
			inc eax
		if CheckBadLines
		.else
			inc ebx
		endif
		.endif
		endif
	.endif
	inc edi
	dec ecx
	jge @B						; signed because a nullstring might have been passed
	if CheckBadLines
		mov BadLines, ebx
	endif
	mov [esp+32-4], eax		; popped eax will contain the counter
	popad						; restore all registers
	ret 8
getlinesJJ endp
getlinesJJE:

end start
OxPT_Linker	polink	; delete the red x if you want to use Pelle's linker
OPT_WAIT	0	; 1=wait until a key is pressed before closing the DOS box
OPT_Assembler	ml
OPT_DelTmp	0
OPT_Tmp2Asm	1
OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
